require("Render3D.lua")
if arg[1] == "profiler" then
	profiler = require("profiler.lua")
	profiler.start()
	profilecount = 0
end

MyRender3D = Render3D:new(0,0,math.sqrt(3),1024,1024,4.1) --veiwer is centerd and has 60 degree feild of veiw, min veiw distance is 4.1

function love.load()
	love.graphics.setFont( "arialbd.ttf", 20 )
	MyRender3D:translate(0,0,20)
	MyRender3D.lx = -0.7
	MyRender3D.ly = 0
	MyRender3D.lz = -0.3
end

function love.draw()
	MyRender3D:clear()
	love.graphics.setBackgroundColor(255,255,255)
	
	MyRender3D:color(255,0,0,255)
	
	MyRender3D:normal(0,0,1)
	MyRender3D:triangle("fill",0,0,0,4,0,0,4,4,0)
	MyRender3D:triangle("fill",0,0,0,0,4,0,4,4,0)
	
	MyRender3D:normal(-1,0,0)
	MyRender3D:triangle("fill",0,4,0,0,0,0,0,4,4)
	MyRender3D:triangle("fill",0,0,0,0,4,4,0,0,4)
	
	MyRender3D:normal(1,0,0)
	MyRender3D:triangle("fill",4,0,0,4,4,0,4,4,4)
	MyRender3D:triangle("fill",4,0,0,4,4,4,4,0,4)
	
	MyRender3D:normal(0,0,-1)
	MyRender3D:triangle("fill",4,0,4,0,0,4,4,4,4)
	MyRender3D:triangle("fill",0,0,4,0,4,4,4,4,4)
	
	MyRender3D:normal(0,-1,0)
	MyRender3D:triangle("fill",0,0,4,0,0,0,4,0,4)
	MyRender3D:triangle("fill",0,0,0,4,0,0,4,0,4)
	
	MyRender3D:normal(0,1,0)
	MyRender3D:triangle("fill",0,4,0,0,4,4,4,4,4)
	MyRender3D:triangle("fill",0,4,0,4,4,0,4,4,4)
	
	MyRender3D:push()
	for i=0,50,1 do
		MyRender3D:translate(0,0,8)
		
		MyRender3D:normal(0,0,1)
		MyRender3D:triangle("fill",0,0,0,4,0,0,4,4,0)
		MyRender3D:triangle("fill",0,0,0,0,4,0,4,4,0)
		
		MyRender3D:normal(-1,0,0)
		MyRender3D:triangle("fill",0,4,0,0,0,0,0,4,4)
		MyRender3D:triangle("fill",0,0,0,0,4,4,0,0,4)
		
		MyRender3D:normal(1,0,0)
		MyRender3D:triangle("fill",4,0,0,4,4,0,4,4,4)
		MyRender3D:triangle("fill",4,0,0,4,4,4,4,0,4)
		
		MyRender3D:normal(0,0,-1)
		MyRender3D:triangle("fill",4,0,4,0,0,4,4,4,4)
		MyRender3D:triangle("fill",0,0,4,0,4,4,4,4,4)
		
		MyRender3D:normal(0,-1,0)
		MyRender3D:triangle("fill",0,0,4,0,0,0,4,0,4)
		MyRender3D:triangle("fill",0,0,0,4,0,0,4,0,4)
		
		MyRender3D:normal(0,1,0)
		MyRender3D:triangle("fill",0,4,0,0,4,4,4,4,4)
		MyRender3D:triangle("fill",0,4,0,4,4,0,4,4,4)
	end
	MyRender3D:pop()
	
	MyRender3D:present()
	
	love.graphics.setColor(0,0,0,255)
	love.graphics.print("x,y,z: "..MyRender3D.x..","..MyRender3D.y..","..MyRender3D.z,50,50)
	love.graphics.print("rx,ry,rz: "..MyRender3D.rx..","..MyRender3D.ry..","..MyRender3D.rz,50,80)
	
	love.graphics.print("controls:\n   w,s: z-axis\n   a,d: x-axis\n   up,down: y-axis\n   r,t: x rotation\n   q,e: z rotation\n   z,x: y rotation",50,150)
end

function love.update(dt)
	if love.keyboard.isDown("w") then
		MyRender3D:translate(0,0,0.1*dt*60)
	end
	if love.keyboard.isDown("a") then
		MyRender3D:translate(-0.1*dt*60,0,0)
	end
	if love.keyboard.isDown("s") then
		MyRender3D:translate(0,0,-0.1*dt*60)
	end
	if love.keyboard.isDown("d") then
		MyRender3D:translate(0.1*dt*60,0,0)
	end
	if love.keyboard.isDown("up") then
		MyRender3D:translate(0,0.1*dt*60,0)
	end
	if love.keyboard.isDown("down") then
		MyRender3D:translate(0,-0.1*dt*60,0)
	end
	if love.keyboard.isDown("r") then
		MyRender3D:rotate(0.05*dt*60,0,0)
	end
	if love.keyboard.isDown("t") then
		MyRender3D:rotate(-0.05*dt*60,0,0)
	end
	if love.keyboard.isDown("q") then
		MyRender3D:rotate(0,0,0.05*dt*60)
	end
	if love.keyboard.isDown("e") then
		MyRender3D:rotate(0,0,-0.05*dt*60)
	end
	if love.keyboard.isDown("z") then
		MyRender3D:rotate(0,0.05*dt*60,0)
	end
	if love.keyboard.isDown("x") then
		MyRender3D:rotate(0,-0.05*dt*60,0)
	end
	if arg[1] == "profiler" then
		if profilecount >= 10 then
			profiler.stop()
		end
	end
end

function love.run()
	
    if love.load then love.load() end

    local dt = 0

    -- Main loop time.
    while true do
        if love.timer then
            love.timer.step()
            dt = love.timer.getDelta()
        end
        if love.update then love.update(dt) end -- will pass 0 if love.timer is disabled
        if love.graphics then
            love.graphics.clear()
            if love.draw then love.draw() end
        end

        -- Process events.
        if love.event then
            for e,a,b,c in love.event.poll() do
                if e == "q" then
                    if not love.quit or not love.quit() then
                        if love.audio then
                            love.audio.stop()
                        end
                        return
                    end
                end
                love.handlers[e](a,b,c)
            end
        end

        if love.timer then love.timer.sleep(1) end
        if love.graphics then love.graphics.present() end

    end
end